> For the complete documentation index, see [llms.txt](https://docs.ees.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ees.xyz/execution-modules/regulartimeinterval.md).

# RegularTimeInterval

The `RegularTimeInterval` execution module enables recurring execution of jobs in a fixed time interval. The input bytes to the `onCreateJob` function should follow the structure:

```solidity
uint32 cooldown;
uint40 initialExecutionTime;
```

&#x20;`cooldown` specifies the number of seconds between when the job can be executed. The `initialExecutionTime` value is the UNIX time in seconds when the job can be executed from the first time. If `initialExecutionTime <= block.timestamp`, `block.timestamp` becomes the initial time of execution and the job will be executed immediately.

The contract stores information about each job in a public mapping from job indices to Params structs:

```solidity
struct Params {
    uint40 lastExecution;
    uint32 cooldown;
}
```

The `lastExecution` field is the UNIX time in seconds of when the last execution opened. Initially it will be set to `initialExecutionTime - cooldown`, unless `initialExecutionTime <= block.timestamp`, then it is set to `block.timestamp`. The `lastExecution` value is updated every time the job is executed and there are always `cooldown` seconds between each value of `lastExecution`.

{% hint style="warning" %}
**Warning:** The `onCreateJob` function will revert if  `cooldown < _executionWindow.`
{% endhint %}

{% hint style="warning" %}
**`Warning:`** `lastExecution` is not *necessarily* the last timestamp the job was executed. To get an exact timestamp of when the job is executed, you can listen for the `JobExecuted` event emitted by the `JobRegistry` contract.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ees.xyz/execution-modules/regulartimeinterval.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
